#include "stdinc.h"
#include "server.h"
#include "extern.h"


#define NAME "m_joinflood"
#define AUTHOR "Twitch"
#define VERSION "$Id: m_joinflood.c 1246 2008-08-17 05:11:02Z twitch $"


#define JOIN_DUR 10
#define JOIN_CNT 7
enum MYVERSION {
       MAJOR = 0,
       MINOR = 4,
       PATCH = 0,

};

dlink_list floodchans;

typedef struct floodchan_ {

    char name[34];

    time_t lastjoin;

    time_t joinstart;

    int joincnt;

    int jflood;


    struct floodchan_ *next,*prev;

} FloodChan;


void m_sjoin (Link*, int , char **);
FloodChan* Find_FloodChan(char* chan);
void chk_floods();

int Module_Init()
{

      RegisterModule(NAME,AUTHOR,VERSION, MAJOR, MINOR, PATCH);
      AddServCmd ("SJOIN", m_sjoin);
      AddTimedEvent ("JOIN FLOOD", chk_floods, 120);

      floodchans.head = floodchans.tail = NULL;

      return MOD_ERR_OK;
}

void Module_Close()
{
	return;
}

void m_sjoin (Link *li, int argc, char **argv)
{
    int found = 0;
	time_t	thisjoin;
	FloodChan* c;
	dlink_node* dl;

    if (sync_state != 3)
            return;

    if (c->jflood == 1)
            return;

    thisjoin = time(NULL);

    //add a channel setup the info (we will delete this out later)
    if (!(c = Find_FloodChan(argv[2])))
    {

        dl = dlink_create();

        c = (FloodChan*) malloc(sizeof(FloodChan));

        if (!c)
            return;

        strlcpy(c->name,argv[2],sizeof(c->name));

        c->lastjoin = time(NULL);
        c->joincnt = 1;
        c->jflood = 0;
        c->joinstart = time(NULL);

        dlink_add_tail (c, dl, &floodchans);

        return;
    }


    if (((thisjoin - c->lastjoin) <=  JOIN_DUR) ||
       ((thisjoin - c->joinstart) <= JOIN_DUR)) {

        c->joincnt++;

    }  else {

            c->lastjoin = thisjoin;
            return;
    }


	if ((c->joincnt > JOIN_CNT) && (c->jflood != 1))
	{
		c->jflood = 1;

		ircd_wallop(s_Guardian->nick,"\002Flood Detected:\002 Detected JOIN/PART flood in %s (%d joins in %lu seconds)",
					c->name,c->joincnt,(thisjoin - c->joinstart));

		sendto_logchan("\002Flood:\002 %s has been join/part flooded - setting modes",c->name);

		send_line(":%s JOIN %s",s_Guardian->nick,c->name);
        send_line(":%s MODE %s :+iRsm",s_Guardian->nick,c->name);

        return;
	}

	c->lastjoin = thisjoin;

	return;
}


void chk_floods()
{
	dlink_node *dl,*tdl;
	FloodChan* c;
	time_t thistime = time(NULL);

  	DLINK_FOREACH (dl, floodchans.head)
    {
       	c   = dl->data;

        if ((c->jflood == 1) && ((thistime - c->lastjoin) >= 60))
        {
        	send_line(":%s MODE %s :-iRsm",s_Guardian->nick,c->name);
			sendto_logchan("\002Flood:\002 Removing FLOOD status from %s",c->name);
			send_line(":%s PART %s :Network Security Services",s_Guardian->nick,c->name);

 			//reset channel statistics
			tdl  = dlink_find_delete (c,&floodchans);
            dlink_free (tdl);

		}

        //clean up the list.
		else if ((c->jflood == 0) && ((thistime - c->lastjoin) >= 120))
		{
            tdl  = dlink_find_delete (c,&floodchans);
            dlink_free (tdl);
		}

   	}
}


FloodChan* Find_FloodChan(char* chan)
{
    dlink_node* dl;
    FloodChan*   c;

    DLINK_FOREACH (dl, floodchans.head)
    {
        c = dl->data;

        if ((strcasecmp (c->name, chan)) == 0)
            return c;
    }

    return NULL;
}

